"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeycloakService = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const Keycloak = __importStar(require("keycloak-connect"));
let KeycloakService = class KeycloakService {
    constructor(configService) {
        this.clientsCache = new Map();
        this.clientId = configService.get('CLIENT_ID');
        this.clientSecret = configService.get('CLIENT_SECRET');
        this.authorizationServerUrl = configService.get('AUTHORIZATION_SERVER_URL');
    }
    async validateAccessToken(realm, token) {
        const tokenResult = await this.clientForRealm(realm).grantManager.validateAccessToken(token);
        if (typeof tokenResult === 'string')
            return true;
        throw new Error('Invalid access token');
    }
    async checkScope(realm, request, scope, resource) {
        const keycloak = this.clientForRealm(realm);
        const permission = `${resource ? resource : this.clientId}:${scope}`;
        const enforcerFn = this.clientForRealm(realm).enforcer(permission, { response_mode: 'token' });
        await new Promise((resolve, reject) => {
            keycloak.accessDenied = () => reject(new Error(`Missing required '${permission}' permission`));
            enforcerFn(request, null, resolve);
        });
        return true;
    }
    async hasRole(realm, token, roles) {
        const grant = await this.clientForRealm(realm).grantManager.createGrant({
            access_token: token,
        });
        const hasRole = roles.some((role) => grant.access_token.hasRole(role));
        if (hasRole)
            return true;
        throw new Error('Missing required role');
    }
    clientForRealm(realm) {
        if (!this.clientsCache.has(realm)) {
            this.clientsCache.set(realm, new Keycloak.default({}, {
                resource: this.clientId,
                realm,
                authServerUrl: this.authorizationServerUrl,
                secret: this.clientSecret,
            }));
        }
        return this.clientsCache.get(realm);
    }
};
KeycloakService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [config_1.ConfigService])
], KeycloakService);
exports.KeycloakService = KeycloakService;
//# sourceMappingURL=keycloak.service.js.map